// -*-C++-*-
//
// File:      OmSourceBrowser.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri Sep  6 11:11:03 MEST 2002
// Usage:     -
// Info:      -

#ifndef OmSourceBrowser_h
#define OmSourceBrowser_h
#include <qwidget.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qstring.h>
#include <qspinbox.h>
// forward declarations
class OmSourceParameter;
class OmSourceEditor;
class OmImageDisplay;
class OmSourceLog;
class QListBox;
class QComboBox;
class QPushButton;
class QProgressDialog;
class QSpinBox;

class QLabel;
//extern F90MODVARDEF(PhotometryParameters, omsource_glue, myphotometryparameters);

class OmSourceBrowser : public QWidget
{
  Q_OBJECT
public:
  OmSourceBrowser(QWidget* parent,const char* name=0);
  virtual ~OmSourceBrowser();
  void Initialise();

signals:
  // Emitted whenever we expect the user to add sources within the display
  //  void suspendedForAddition(); 
      void HideParent();
      void ShowParent();
      void SetCaption(QString caption);
      void SetStatusBarMessage(char *caption, long time);
      void SetStatusBarMessage(char *caption);

      void Exit();

public  slots:

private slots:

  void edit(int); // source with id
  void edit1(int);
  void recompute(const OmSourceParameter& s);
  void viewAll(); // zoom out and display all sources

  void addSources(); // triggered by _addSourcesBtn
  void deleteSource(); // triggered by _editor
  void setListBoxItem(int index) {_list->setCurrentItem(index - 1); };
  void editSource() {int index = _list->currentItem(); edit(index); }; 
  void SetSpinBoxValue(int num)   { _spinBoxNumber->setValue(num + 1); };
  void Cancel() { quitProgram(); };   
  
  
  void print1(); 
  void print2(); 

  void quitProgram() {};
protected:
  // only derived classes can use these

  //  PhotometryParameters photParameters;

private:
  // disabled member functions

  OmSourceBrowser(const OmSourceBrowser&);
  OmSourceBrowser& operator=(const OmSourceBrowser&);

  //
  void refreshListBox();



  typedef void(OmSourceBrowser::*PRINT)(QPrinter* printer, QPainter* p,  
				       QFontMetrics *fm,  QPaintDeviceMetrics* metrics);

  PRINT Print;
  void printLog(QPrinter* printer, QPainter* p,  
		      QFontMetrics *fm,  QPaintDeviceMetrics* metrics);

  void printAverages(QPrinter* printer, QPainter* p,  
		      QFontMetrics *fm,  QPaintDeviceMetrics* metrics);

  void print();
  void sourceDetection(char fileName[]);   
  void loadFileNames();




  // member data
  bool             _changed; 
  float _calApertureRadius;
  OmImageDisplay*  _display;  
  OmSourceEditor*  _editor;
  QProgressDialog* _progress;
  //  QListBox*        _list;

  QComboBox*        _list;
  QComboBox*        _averageMagList;

  QSpinBox*        _spinBoxNumber; 


  QPushButton*     _viewAllBtn;
  QPushButton*     _addSourcesBtn;
  QPushButton*     _printLogBtn;
  QPushButton*     _printAveragesBtn;
  QPushButton*     _editSource;

  OmSourceLog*     _logger;
  QLabel* _magnitudeLabel;

  int              _current;
  float* _magnitude;
  float* _magnitudeError;
  int _count;   
  int _sourceNo;

  char _imageFileName[256];       // For the image file name
  char _oldSourceListFile[256];   // For the old source-list file name

  char _newSourceListFile[256];   // For the new source-list file name

   
};
//float OmSourceBrowser::_calApertureRadius = 0.0;



#endif
