// -*-C++-*-
//
// File:      OmSourceLog.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Wed Oct  2 15:31:02 CEST 2002
// Usage:     -
// Info:      -

#include "OmSourceLog.h"
#include "OmSourceParameters.h"
#include <qstring.h>
/*****************************************************
*
*****************************************************/
OmSourceLog::OmSourceLog(QWidget* parent, const char* name) : QTable(parent, name)
{
    int noColumns = 7;

    setNumCols( noColumns);
    setNumRows( 1);
    setText(0, 0,"Aperture Rad");
 

    setText(0, 1,"Inner Bgr Ann Rad");
 
    setText(0, 2,"Outer Bgr Ann Rad");
  

    setText(0, 3,"Magnitude");
 

    setText(0, 4,"Mag error)");
 

    setText(0, 5,"Significance");
 

    setText(0, 6,"Coincidence corr");
 

    /********************************************
    * Adjust the size of the cells
    *******************************************/
    for (int i = 0; i < noColumns; i++)
    {   
      //        QString label = text(0, i);
	//        setColumnWidth(i, label.length() * 7);
        setColumnWidth(i, text(0, i).length() * 7);


    }
}
/*****************************************************
*
*****************************************************/
OmSourceLog::~OmSourceLog()
{
}
/*****************************************************
*
*****************************************************/
void OmSourceLog::add(const OmSourceParameter& s)
{
    int rowNo = numRows();

    setNumRows(rowNo + 1);
    int colNo = 0;

    QString text;

    setText(rowNo, colNo++, text.sprintf("%2d", int(s.photometryradius)));

    setText(rowNo, colNo++, text.sprintf("%2d", int(s.innerbackgroundradius)));
    setText(rowNo, colNo++, text.sprintf("%2d", int(s.outerbackgroundradius)));

    setText(rowNo, colNo++,  text.sprintf("%5.2f", s.magnitude));
    setText(rowNo, colNo++,  text.sprintf("%5.2f", s.magnitudeerror));


    setText(rowNo, colNo++, text.sprintf("%.1f", s.significance));

    setText(rowNo, colNo++, text.sprintf("%.1f", s.coincidencecorrection));

}
/*****************************************************
*
*****************************************************/
QString OmSourceLog::getLine(const int index)
{
    QString line;
    for (int i = 0; i < numCols(); i++)
      line += text(index, i) + " ";

    return line;
}
/*****************************************************
*
*****************************************************/
void OmSourceLog::restart()
{
    setNumRows(1);
}







