// -*-C++-*-
//
// File:      OmSourceParameters.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri Aug  9 16:49:17 MEST 2002

#ifndef OmSourceParameters_h
#define OmSourceParameters_h

#include "DopeVector.h"

// equivalent of f90::type(OmSourceParameter)
struct OmSourceParameter {
  OmSourceParameter() :
    xcoord(0), xcoorderror(0), ycoord(0), ycoorderror(0),
    rightascension(0),declination(0),
    positionerror(0),significance(0),
    rawcountrate(0), rawcountrateerror(0),
    countrate(0),countrateerror(0),
    coincidencecorrection(0), psf1correction(0),psf2correction(0),
    rawbackgroundcountrate(0),backgroundcountrate(0),
    magnitude(0),magnitudeerror(0),
    calapertureradius(0), photometryradius(0),   // was 0
    innerbackgroundradius(0),outerbackgroundradius(0),
    semia(0),semib(0),nosourcepixels(0),
    extensionflag(0),confusionflag(0), qualityflag(0)
  {
  }
  float xcoord;
  float xcoorderror;
  float ycoord;
  float ycoorderror;
  double rightascension;
  double declination;
  float positionerror;
  float significance;
  float rawcountrate;
  float rawcountrateerror;
  float countrate;
  float countrateerror;
  float coincidencecorrection;
  float psf1correction;
  float psf2correction;
  float rawbackgroundcountrate;
  float backgroundcountrate;
  float magnitude;
  float exposure;
  float magnitudeerror;
  float calapertureradius;
  float photometryradius;
  float innerbackgroundradius;
  float outerbackgroundradius;
  float semia;
  float semib;
  float pasource;
  int nosourcepixels;
  Integer1 extensionflag;
  Integer1 confusionflag;
  Integer1 qualityflag;
};
/*****************************************************
 The observation details
*****************************************************/
struct PhotometryParameters {

  PhotometryParameters() : 
  calApertureRadius(0) 
    
  {
  }
   
    float calApertureRadius;
};
class OmSourceParameters;
F90MODPROCDEF(void,omsourceparameter_mod,new_)(OmSourceParameters*,const int&, const int&);
F90MODPROCDEF(void,omsourceparameter_mod,delete_)(OmSourceParameters*);


class OmSourceParameters : public DopeVector<OmSourceParameter>
{
public:
  // f90:: allocate(OmSourceParameter(length))
  OmSourceParameters(int length)
  {
    int lbound=1;
    int ubound=length;
    F90MODPROC(omsourceparameter_mod,new_)(this,lbound,ubound);
  }

  // f90:: allocate(OmSourceParameter(lbound:ubound))
  OmSourceParameters(int lbound,int ubound)
  {
    F90MODPROC(omsourceparameter_mod,new_)(this,lbound,ubound);
  }
  
  // f90:: deallocate(OmSourceParameter)
  ~OmSourceParameters()
  {
    F90MODPROC(omsourceparameter_mod,delete_)(this);
  }
private:
   // disabled member functions
  OmSourceParameters();
  OmSourceParameters(const OmSourceParameters&);
  OmSourceParameters& operator=(const OmSourceParameters&);
};



#endif
