// -*-C++-*-
//
// File:      OmSourceRegions.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Tue Sep 10 10:58:50 CEST 2002
// Usage:     interface of C++/f90
// Info:      

#ifndef OmSourceRegions_h
#define OmSourceRegions_h
#include "Region.h"     // Point
#include "DopeVector.h"

// forward declaration of f90-methods
class OmSourceRegions;
F90MODPROCPROTO(void,omsourceregion_mod,new_)(OmSourceRegions*,const int&, const int&);
F90MODPROCPROTO(void,omsourceregion_mod,delete_)(OmSourceRegions*);


// A Point<float> is equivalent to f90::type(OmSourceRegion)
class OmSourceRegions : public DopeVector<Point<float> > 
{
public:
  OmSourceRegions(int length)
  {
    int lbound=1;
    int ubound=length;
    F90MODPROC(omsourceregion_mod,new_)(this,lbound,ubound);
  }
  OmSourceRegions(int lbound,int ubound)
  {
    F90MODPROC(omsourceregion_mod,new_)(this,lbound,ubound);
  }

  ~OmSourceRegions()
  {
    F90MODPROC(omsourceregion_mod,delete_)(this);
  }
private:
   // disabled member functions
  OmSourceRegions();
  OmSourceRegions(const OmSourceRegions&);
  OmSourceRegions& operator=(const OmSourceRegions&);
};

#endif
